unit MainUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, PGTray95, StdCtrls, ExtCtrls, Just1_32, registry;

type
  TMainForm = class(TForm)
    pg: TPGTrayIcon95;
    pm: TPopupMenu;
    Exit1: TMenuItem;
    JustOne321: TJustOne32;
    N1: TMenuItem;
    N2: TMenuItem;
    Button1: TButton;
    Label1: TLabel;
    Label2: TLabel;
    GroupBox1: TGroupBox;
    cbShift: TCheckBox;
    cbAlt: TCheckBox;
    cbCtrl: TCheckBox;
    cbBeep: TCheckBox;
    cbShow: TCheckBox;
    Label3: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Exit1Click(Sender: TObject);
    procedure N2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var

  MainForm: TMainForm;
  reg : TregIniFile;

  function SetHook(Handle : hWND; key : integer):Boolean;
            external 'cstdll.dll';
  function UnHookHook:Boolean; external 'cstdll.dll';

implementation

{$R *.DFM}

procedure TMainForm.FormCreate(Sender: TObject);
begin
  if not SetHook(Application.Handle, $01) then
    begin
      MessageDlg('   !',mtError, [mbOk],0);
      Exit1Click(Sender);
    end;
  reg:=TRegIniFile.Create('Software\JaM Software\CST');
  with reg do begin
    cbShow.checked:=ReadInteger('', 'ShowOnStartUp', 1)<>0;
    cbBeep.checked:=ReadInteger('', 'beep', 1)<>0;
    cbShift.checked:=ReadInteger('', 'shift', 0)<>0;
    cbAlt.checked:=ReadInteger('', 'alt', 0)<>0;
    cbCtrl.checked:=ReadInteger('', 'ctrl', 0)<>0;
    end;
  reg.Free;
  pg.Hint:='Translate: ';
  if cbShift.checked then pg.Hint:=pg.Hint+'Shift+';
  if cbAlt.checked then pg.Hint:=pg.Hint+'Alt+';
  if cbCtrl.checked then pg.Hint:=pg.Hint+'Ctrl+';
  pg.Hint:=pg.Hint+'F12';
  if cbShow.checked then Show;
end;

procedure TMainForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Action:=caHide;
end;

procedure TMainForm.Exit1Click(Sender: TObject);
begin
  close;
  UnHookHook;
  MainForm.Free;
  Application.Terminate;
end;

procedure TMainForm.N2Click(Sender: TObject);
begin
  pg.HideIcon;
  Show;
end;

procedure TMainForm.Button1Click(Sender: TObject);
begin
  reg:=TRegIniFile.Create('Software\JaM Software\CST');
  with reg do begin
    WriteInteger('', 'ShowOnStartUp', Integer(cbShow.checked));
    WriteInteger('', 'beep', Integer(cbBeep.checked));
    WriteInteger('', 'shift', Integer(cbShift.checked));
    WriteInteger('', 'alt', Integer(cbAlt.checked));
    WriteInteger('', 'ctrl', Integer(cbCtrl.checked));
    end;
  reg.Free;
  hide;
  pg.Hint:='Translate: ';
  if cbShift.checked then pg.Hint:=pg.Hint+'Shift+';
  if cbAlt.checked then pg.Hint:=pg.Hint+'Alt+';
  if cbCtrl.checked then pg.Hint:=pg.Hint+'Ctrl+';
  pg.Hint:=pg.Hint+'F12';
  pg.ShowIcon;
end;

end.
