unit Translator;

interface

uses Wintypes,Winprocs,Messages, SysUtils;

function SetHook(Handle : hWND; key : integer):Boolean;
         export;
function UnHookHook:Boolean;export;
function HookProc(Code:integer; wParam: wparam; lParam: Longint): Longint; stdcall;export;

var HookedAlready:Boolean;

const
   ctrl  : integer = 0;
   alt   : integer = 0;
   shift : integer = 0;
   beep  : integer = 0;

implementation

var
   ourHook:HHook;
   WND : hWND;


const EngStr : string[64] = 'QWERTYUIOP{}ASDFGHJKL:"ZXCVBNM<>qwertyuiop[]asdfghjkl;'#39'zxcvbnm,.';
      RusStr : string[64] = '';

procedure Translate;
var
  Data: THandle; i, Len : integer;
  Buffer : array[0..255] of char;
  b : boolean; s1, s2 : string[64];
  DataPtr: Pointer;
begin
  b:=false;
  if not openclipboard(WND) then exit;
  Data := GetClipboardData(CF_TEXT);
  if Data = 0 then exit else
  begin
    Len := StrLen(StrLCopy(Buffer, GlobalLock(Data), 255));
    GlobalUnlock(Data);
  end;
  i:=0;
  while (not b) and (i<Len) do begin
    if pos(buffer[i], EngStr)<>0 then begin i:=1; b:=true end
    else if pos(buffer[i], RusStr)<>0 then begin i:=2; b:=true end
    else Inc(i);
    end;
  if not b then exit;
  if i=1 then begin s1:=EngStr; s2:=RusStr end
         else begin s2:=EngStr; s1:=RusStr end;
  for i:=0 to len-1 do
    if pos(buffer[i], s1)<>0 then buffer[i]:=s2[pos(buffer[i], s1)];
//---------------------------------------------------------
    emptyclipboard;
    Data := GlobalAlloc(GMEM_MOVEABLE, Len+1);
    try
      DataPtr := GlobalLock(Data);
      try
        Move(Buffer, DataPtr^, Len+1);
        SetClipboardData(CF_TEXT, Data);
      finally
        GlobalUnlock(Data);
      end;
    except
      GlobalFree(Data);
      raise;
    end;

//----------------------------------------------------------
  closeclipboard;
end;

function SetHook(Handle : hWND; key : integer):Boolean;
begin
  WND:=Handle;
  if HookedAlready then exit;
  ourHook:=SetWindowsHookEx(WH_KEYBOARD,HookProc,HInstance,0);
  HookedAlready:=ourHook<>0;
  Result:=HookedAlready;
end;

function UnHookHook:Boolean;
begin
  UnHookWindowsHookEx(ourHook);
  HookedAlready:=False;
end;

procedure SetTrKey;
const
  skey = 'Software\JaM Software\CST';
var
  ikey : Integer;
  DataType: Integer;
  Size : integer;
begin
  if RegOpenKeyEx(HKEY_CURRENT_USER,skey,0,KEY_ALL_ACCESS,ikey)=ERROR_SUCCESS
    then begin
      Size:=SizeOf(Integer);
      RegQueryValueEx(iKey, 'shift', nil, @DataType, @shift,@Size);
      RegQueryValueEx(iKey, 'ctrl', nil, @DataType, @ctrl,@Size);
      RegQueryValueEx(iKey, 'alt', nil, @DataType, @alt,@Size);
      RegQueryValueEx(iKey, 'beep', nil, @DataType, @beep,@Size);
      shift:=shift-48;
      ctrl:=ctrl-48;
      alt:=alt-48;
      beep:=beep-48;
      end
    else begin
      shift:=0;
      ctrl:=0;
      alt:=0;
      beep:=1;
      end;
end;

function CheckSpec : boolean;
begin
  Result:=true;
  SetTrKey;
  if ((GetKeyState(vk_shift) and $8000)=$8000) then
   begin if (shift<>1) then result:=false end
  else
   if (shift<>0) then result:=false;
  if ((GetKeyState(vk_menu) and $8000)=$8000) then
   begin if (alt<>1) then result:=false end
  else
   if (alt<>0) then result:=false;
  if ((GetKeyState(vk_control) and $8000)=$8000) then
   begin if (ctrl<>1) then result:=false end
  else
   if (ctrl<>0) then result:=false;
  if (Result=true) and (beep=1) then MessageBeep(0);
end;

function HookProc(Code:integer; wParam: wparam; lParam: Longint): Longint;
begin
    if lparam and $80000000 = $80000000 then  {bit 31 = "key-down"}
    if (wparam = vk_F12) and CheckSpec then Translate;
    result:=CallNextHookEx(ourHook,Code,wParam,lParam);
end;


end.
